/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the DataSourceProperties type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DataSourceProperties{}

// DataSourceProperties struct for DataSourceProperties
type DataSourceProperties struct {
	AllowCustom bool `json:"allow_custom"`
	Properties []DataSourceProperty `json:"properties"`
}

// NewDataSourceProperties instantiates a new DataSourceProperties object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDataSourceProperties(allowCustom bool, properties []DataSourceProperty) *DataSourceProperties {
	this := DataSourceProperties{}
	this.AllowCustom = allowCustom
	this.Properties = properties
	return &this
}

// NewDataSourcePropertiesWithDefaults instantiates a new DataSourceProperties object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDataSourcePropertiesWithDefaults() *DataSourceProperties {
	this := DataSourceProperties{}
	return &this
}

// GetAllowCustom returns the AllowCustom field value
func (o *DataSourceProperties) GetAllowCustom() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.AllowCustom
}

// GetAllowCustomOk returns a tuple with the AllowCustom field value
// and a boolean to check if the value has been set.
func (o *DataSourceProperties) GetAllowCustomOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AllowCustom, true
}

// SetAllowCustom sets field value
func (o *DataSourceProperties) SetAllowCustom(v bool) {
	o.AllowCustom = v
}

// GetProperties returns the Properties field value
func (o *DataSourceProperties) GetProperties() []DataSourceProperty {
	if o == nil {
		var ret []DataSourceProperty
		return ret
	}

	return o.Properties
}

// GetPropertiesOk returns a tuple with the Properties field value
// and a boolean to check if the value has been set.
func (o *DataSourceProperties) GetPropertiesOk() ([]DataSourceProperty, bool) {
	if o == nil {
		return nil, false
	}
	return o.Properties, true
}

// SetProperties sets field value
func (o *DataSourceProperties) SetProperties(v []DataSourceProperty) {
	o.Properties = v
}

func (o DataSourceProperties) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DataSourceProperties) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["allow_custom"] = o.AllowCustom
	toSerialize["properties"] = o.Properties
	return toSerialize, nil
}

type NullableDataSourceProperties struct {
	value *DataSourceProperties
	isSet bool
}

func (v NullableDataSourceProperties) Get() *DataSourceProperties {
	return v.value
}

func (v *NullableDataSourceProperties) Set(val *DataSourceProperties) {
	v.value = val
	v.isSet = true
}

func (v NullableDataSourceProperties) IsSet() bool {
	return v.isSet
}

func (v *NullableDataSourceProperties) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataSourceProperties(val *DataSourceProperties) *NullableDataSourceProperties {
	return &NullableDataSourceProperties{value: val, isSet: true}
}

func (v NullableDataSourceProperties) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataSourceProperties) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


